#define Band80 6          
#define Band40 7          
#define Band20 8          
#define Step10 9         
#define Step100 10       
#define Step1000 11       
#define Rele20 0         
#define Rele40 1         
#define Rele80 12        
#include <LiquidCrystal.h>
#include <Rotary.h>      
#include "si5351.h"     
#include <Wire.h> 
Si5351 si5351;            
LiquidCrystal lcd(4, 5, 14, 15, 16, 17);
Rotary r = Rotary(2, 3);                
long NewFreq=3600000;
long Freq=3600000;             
long Step=100;                 
long IF=50000000;             
void display_frequency()
{
uint16_t f;
lcd.setCursor(2, 1);
f = Freq / 1000000;    
if (f < 10)
lcd.print(' ');
lcd.print(f);
lcd.print('.');
f = (Freq % 1000000) / 1000;
if (f < 100)
lcd.print('0');
if (f < 10)
lcd.print('0');
lcd.print(f);
lcd.print('.');
f = Freq % 1000;
if (f < 100)
lcd.print('0');
if (f < 10)
lcd.print('0');
lcd.print(f);
lcd.print("Hz ");
lcd.setCursor(0, 1);
}
void setup() 
{
lcd.begin(16, 2);
si5351.init(SI5351_CRYSTAL_LOAD_8PF, 0, 148400);  
Wire.begin();
//Serial.begin(9600);   
r.begin();          
PCICR |= (1 << PCIE2);
PCMSK2 |= (1 << PCINT18) | (1 << PCINT19);
sei();                                    
pinMode(Band80, INPUT_PULLUP);   
pinMode(Band40, INPUT_PULLUP);    
pinMode(Band20, INPUT_PULLUP);    
pinMode(Step10, INPUT_PULLUP);   
pinMode(Step100, INPUT_PULLUP);   
pinMode(Step1000, INPUT_PULLUP);  
pinMode(Rele20, OUTPUT);
pinMode(Rele40, OUTPUT);
pinMode(Rele80, OUTPUT);
si5351.drive_strength (SI5351_CLK1, SI5351_DRIVE_8MA);
si5351.drive_strength (SI5351_CLK0, SI5351_DRIVE_8MA);
si5351.set_freq(IF, SI5351_CLK1);
si5351.set_freq(NewFreq*100ULL+IF, SI5351_CLK0);
display_frequency();
lcd.setCursor(0, 0);
lcd.print("RV3EFF");
lcd.setCursor(8, 0);
lcd.print("Step=100");
lcd.print(" ");
digitalWrite(Rele20, LOW);
digitalWrite(Rele40, LOW);
digitalWrite(Rele80, HIGH);
}
void loop() {
if (digitalRead(Band80) == LOW) {      
delay(50);
NewFreq=3600000; 
display_frequency();
digitalWrite(Rele20, LOW);
digitalWrite(Rele40, LOW);
digitalWrite(Rele80, HIGH);
}
if (digitalRead(Band40) == LOW) {      
delay(50);
NewFreq=7060000; 
display_frequency();
digitalWrite(Rele20, LOW);
digitalWrite(Rele40, HIGH);
digitalWrite(Rele80, LOW);
}
if (digitalRead(Band20) == LOW) {      
delay(50);
NewFreq=14100000; 
display_frequency();
digitalWrite(Rele20, HIGH);
digitalWrite(Rele40, LOW);
digitalWrite(Rele80, LOW);
}
if (digitalRead(Step10) == LOW) {      
delay(50);
Step=10; 
lcd.setCursor(8, 0);
lcd.print("Step=10");
lcd.print(" ");
}
if (digitalRead(Step100) == LOW) {     
delay(50);
Step=100; 
lcd.setCursor(8, 0);
lcd.print("Step=100");
lcd.print(" ");
}
if (digitalRead(Step1000) == LOW) {    
delay(50);
Step=1000; 
lcd.setCursor(8, 0);
lcd.print("Step=1k");
lcd.print(" ");
}
if (NewFreq!=Freq) {
if (NewFreq < 10000000) {
si5351.set_freq(NewFreq*100ULL+IF, SI5351_CLK0);
}
else {
si5351.set_freq(NewFreq*100ULL-IF, SI5351_CLK0); 
}
Freq=NewFreq;
display_frequency();
}
}
ISR(PCINT2_vect) {
unsigned char result = r.process();
if (result == DIR_NONE) {
}
else if (result == DIR_CW) {
NewFreq+=Step;
}
else if (result == DIR_CCW) {
NewFreq-=Step;
}
}
